/****************************************************************************/
/* Ώۃ}CR R8C/M12A                                                    */
/* ̧ٓe     }CRJ[p[^hCuVer.4 or Ver.5̐        */
/* o[W   Ver.1.00                                                    */
/* Date         2012.05.14                                                  */
/* Copyright    lTX}CRJ[[                            */
/****************************************************************************/
/*
R8C/M12A}CR̃sAL̂悤Ɍ܂B
 1(P4_2)  2(P3_7)  3(PA_0)  4(P4_7) 6(P4_6) 9(P3_5) 10(P3_4) 11(P3_3) 12(P4_5)
ڑ    ڑ   ڑ   ڑ  ڑ  ڑ  ڑ   ڑ   ڑ

13(P1_7) 14(P1_6) 15(P1_5) 16(P1_4) 17(P1_3) 18(P1_2) 19(P1_1) 20(P1_0)
2(b7) 3(b6) 9(b0) 6(b3) 4(b5) 7(b2) 8(b1) 5(b4)
śA[^hCuVer.410sRlN^̔ԍ
*/

/*======================================*/
/* CN[h                         */
/*======================================*/
#include "sfr_r8m12a.h"                 /* R8C/M12A SFR̒`t@C   */

/*======================================*/
/* V{`                         */
/*======================================*/

/* 萔ݒ */
#define PWM_CYCLE       39999           /* [^PWM̎              */
#define SERVO_CENTER    3750            /* T[{̃Z^l             */
#define HANDLE_STEP     22              /* 1K̒l                    */

/*======================================*/
/* vg^Cv錾                     */
/*======================================*/
void init( void );
void timer( unsigned long timer_set );
unsigned char pushsw_get( void );
void led_out( unsigned char led );
void motor( int accele_l, int accele_r );
void handle( int angle );

/************************************************************************/
/* CvO                                                     */
/************************************************************************/
void main( void )
{
    init();                             /*                        */

    /* vbVXCb`܂LED̓_ */
    while( pushsw_get() == 0 ) {
        led_out( 0x01 );
        timer( 100 );
        led_out( 0x02 );
        timer( 100 );
    }

    /* LED */
    led_out( 0x00 );

    /* [^AT[{ */
    while( 1 ) {
        motor( 50, 0 );
        timer( 2000 );

        motor( 0, 50 );
        timer( 2000 );

        motor( -50, 0 );
        timer( 2000 );

        motor( 0, -50 );
        timer( 2000 );

        motor( 0, 0 );

        handle( 30 );
        timer( 2000 );

        handle( -30 );
        timer( 2000 );

        handle( 0 );
        timer( 2000 );
    }
}

/************************************************************************/
/* R8C/M12A XyVt@NVWX^(SFR)̏               */
/************************************************************************/
void init( void )
{
    /* |[g̓o͐ݒ */
    pd1 = 0xdf;                         /* |[g1̓o͐ݒ          */
    pd3 = 0xff;                         /* |[g3̓o͐ݒ          */
    pd4 = 0xff;                         /* |[g4̓o͐ݒ          */
    pda = 0xff;                         /* |[gA̓o͐ݒ          */

    /* ^C}RCɂPWMo(3cho) */
    msttrc = 0;                         /* ^C}RCLɂ         */

    p12sel1 = 0;                        /* TRCIOB[q̑I             */
    p12sel0 = 1;                        /* P1_2TRCIOB[qɂ       */

    p13sel1 = 0;                        /* TRCIOC[q̑I             */
    p13sel0 = 1;                        /* P1_3TRCIOC[qɂ       */

    p10sel1 = 0;                        /* TRCIOD[q̑I             */
    p10sel0 = 1;                        /* P1_0TRCIOD[qɂ       */

    pwm2_trcmr = 1;                     /* PWM[h                    */
    pwmd_trcmr = 1;                     /* TRCIODo PWMo͂       */
    pwmc_trcmr = 1;                     /* TRCIOCo PWMo͂       */
    pwmb_trcmr = 1;                     /* TRCIOBo PWMo͂       */

    trccr1 = 0xb0;                      /* JEg\[X = f8          */

    trcgra = PWM_CYCLE;                 /* PWM̐ݒ                */
    trcgrb = 0;                         /* TRCIOB[qON̐ݒ       */
    trcgrc = SERVO_CENTER;              /* TRCIOC[qON̐ݒ       */
    trcgrd = 0;                         /* TRCIOD[qON̐ݒ       */

    ed_trcoer = 0;                      /* TRCIOD̏ó@o͋       */
    ec_trcoer = 0;                      /* TRCIOC̏ó@o͋       */
    eb_trcoer = 0;                      /* TRCIOB̏ó@o͋       */

    cts_trcmr = 1;                      /* TRCCNT JEgJn          */
}

/************************************************************************/
/* ^C}{                                                           */
/* @ ^C}l 1=1ms                                                */
/************************************************************************/
void timer( unsigned long timer_set )
{
    int i;

    do {
        for( i=0; i<871; i++ );
    } while( timer_set-- );
}

/************************************************************************/
/* vbVXCb`lǂݍ                                           */
/* ߂l XCb`l ON:1 OFF:0                                         */
/************************************************************************/
unsigned char pushsw_get( void )
{
    unsigned char sw;

    sw  = ~p1_5;
    sw &= 0x01;

    return  sw;
}

/************************************************************************/
/* LED                                                              */
/* @XCb`l LED0:bit0 LED1:bit1  "0": "1":_              */
/* )0x3LED1:ON LED0:ON  0x2LED1:ON LED0:OFF                       */
/************************************************************************/
void led_out( unsigned char led )
{
    if( led & 0x01 ) {
        p1_6 = 0;
    } else {
        p1_6 = 1;
    }
    if( led & 0x02 ) {
        p1_7 = 0;
    } else {
        p1_7 = 1;
    }
}

/************************************************************************/
/* [^x                                                       */
/* @ [^:-100`100AE[^:-100`100                        */
/*        0Œ~A100Ő]100%A-100ŋt]100%                        */
/* ߂l Ȃ                                                          */
/************************************************************************/
void motor( int accele_l, int accele_r )
{
    unsigned int i;

    /* [^ */
    if( accele_l > 0 ) {
        p1_1 = 0;
    } else if( accele_l < 0 ) {
        p1_1 = 1;
        accele_l = -accele_l;
    }

    if( accele_l == 0 ) {
        if( trcgrb < trcgra ) while( trcgrb >= trccnt );
        trcgrb = trcgra;
    } else if( accele_l >= 100 ) {
        trcgrb = trcgra + 1;
    } else {
        i = (long)(PWM_CYCLE - 1) * accele_l / 100;
        if( trcgrb < trcgra ) while( trcgrb >= trccnt );
        trcgrb = i;
    }

    /* E[^ */
    if( accele_r > 0 ) {
        p1_4 = 0;
    } else if( accele_r < 0 ) {
        p1_4 = 1;
        accele_r = -accele_r;
    }

    if( accele_r == 0 ) {
        if( trcgrd < trcgra ) while( trcgrd >= trccnt );
        trcgrd = trcgra;
    } else if( accele_r >= 100 ) {
        trcgrd = trcgra + 1;
    } else {
        i = (long)(PWM_CYCLE - 1) * accele_r / 100;
        if( trcgrd < trcgra ) while( trcgrd >= trccnt );
        trcgrd = i;
    }
}

/************************************************************************/
/* T[{nh                                                   */
/* @ T[{pxF-90`90                                       */
/*        -90ō90xA0ł܂A90ŉE90x]                  */
/************************************************************************/
void handle( int angle )
{
    unsigned int i;

    /* T[{Etɓꍇ́Au-vu+vɑւĂ */
    i = SERVO_CENTER - angle * HANDLE_STEP;

    if( trcgrc < trcgra ) while( trcgrc >= trccnt );

    /* T[{Etɓꍇ́Au-vu+vɑւĂ */
    trcgrc = i;
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/
